//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "IdCmdTCPServer.hpp"
#include "IdCustomTCPServer.hpp"
#include "IdScheduler.hpp"
#include "IdSchedulerOfThread.hpp"
#include "IdSchedulerOfThreadDefault.hpp"
#include "IdDsnCoreResourceStrings.hpp"
#include "ChatContextData.h"
#include <CheckLst.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <IdAntiFreeze.hpp>
#include <IdAntiFreezeBase.hpp>
#include <IdBaseComponent.hpp>
#include <IdComponent.hpp>
#include <IdIrcServer.hpp>
#include <IdTCPServer.hpp>
#include <IdStackBSDBase.hpp>
//---------------------------------------------------------------------------
class TfrmMain : public TForm
{
__published:	// IDE-managed Components
  TPanel *pnlButtonBar;
  TButton *btnStartStop;
  TButton *btnTestClient;
  TPageControl *pcMain;
  TTabSheet *tsSettings;
  TLabel *Label2;
  TLabel *Label3;
  TLabel *Label4;
  TCheckListBox *lbIPs;
  TComboBox *cbPorts;
  TEdit *edPort;
  TTabSheet *tsProcessLog;
  TListBox *lbProcesses;
  TTabSheet *tsGreeting;
  TPanel *Panel3;
  TLabel *lblUserNamePrompt;
  TEdit *edUserPrompt;
  TMemo *memGreeting;
  TIdAntiFreeze *IdAntiFreeze1;
  TIdSchedulerOfThreadDefault *IdSchedulerOfThreadDefault1;
  TIdIRCServer *Server;
  void __fastcall btnStartStopClick(TObject *Sender);
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall FormDestroy(TObject *Sender);
  void __fastcall ServerStatus(TObject *ASender, const TIdStatus AStatus,
          const AnsiString AStatusText);
  void __fastcall ServerException(TIdContext *AContext,
          Exception *AException);
  void __fastcall FormActivate(TObject *Sender);
  void __fastcall ServerExecute(TIdContext *AContext);
  void __fastcall ServerConnect(TIdContext *AContext);
  void __fastcall ServerDisconnect(TIdContext *AContext);
  void __fastcall edPortKeyPress(TObject *Sender, char &Key);
  void __fastcall btnTestClientClick(TObject *Sender);
  void __fastcall lbProcessesDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
private:	// User declarations
  bool __fastcall CheckStartOK(void);

  bool __fastcall StartServer(void);
  bool __fastcall StopServer(void);

  void __fastcall PopulateIPAddresses(void);
  AnsiString __fastcall PortDescription(const int PortNumber);

  void __fastcall LoadDefaultValues(void);
  void __fastcall SaveDefaultValues(void);

  void __fastcall CheckOptions(void);
  bool __fastcall GetServerOnline(void);

  bool __fastcall InternalServerBeforeStart(void);
  void __fastcall InternalServerAfterStart(void);

  bool __fastcall InternalServerBeforeStop(void);
  void __fastcall InternalServerAfterStop(void);

  void __fastcall Log(AnsiString Msg, TColor Color = clBlack);
  void __fastcall SetControls(void);
public:		// User declarations
  __fastcall TfrmMain(TComponent* Owner);

  void __fastcall WriteMessage(AnsiString Msg);
  void __fastcall MsgAvail(TChatContextData *Sender);

  __property bool ServerOnline = {read=GetServerOnline};
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmMain *frmMain;
//---------------------------------------------------------------------------
#endif
